<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Remote\FileUploader\Server;

class Sm00004000AnexoContratoController extends SMCrud
{
    protected $dataSourceName = 'fct_anexocontrato_operador';
    protected $zhFileUploader;
    
	public function __construct ($crudService, $environment, Server $zhFileUploader) {
        parent::__construct($crudService, $environment);
        $this->zhFileUploader = $zhFileUploader;
    }
    
    public function save(Request $request, Response $response) {
        $row = $request->getDataSet()->getRows()[0];
        
        $row["DSCAMINHO"] = $row["DSCAMINHO"][0]["path"];
        parent::save($request, $response);
    }
    
    public function delete(Request $request, Response $response){
        $row = $request->getRow();
        $this->zhFileUploader->deleteFile($row["DSCAMINHO"]);
        
        parent::delete($request, $response);
        
    }
}

?>