/* Nome: 0001_SRVFUNO_SALDOSLA                                    */

/* Descrio:
   Verifica a diferena de dias entre duas datas, considerando
   apenas dias teis.

   RETORNA: Quantidade de dias                                    */

/* Criao: Newton N. Santos                                      */

CREATE OR REPLACE FUNCTION SALDOSLA
(P_FILIAL IN VARCHAR2,
 P_DTFIM IN DATE,
 P_DTINI IN DATE) RETURN NUMBER IS

 V_RESULT NUMBER;
 V_SALDO  NUMBER;
 V_DTAUX  DATE;
 V_COUNT  NUMBER;

BEGIN
   V_DTAUX  := P_DTFIM;
   V_SALDO  := TRUNC(P_DTFIM) - TRUNC(P_DTINI);
   V_RESULT := V_SALDO;

   IF V_SALDO > 0 THEN
      WHILE V_SALDO <> 0 LOOP
         V_SALDO := V_SALDO - 1;
         V_DTAUX := V_DTAUX - 1;

         SELECT COUNT(*) INTO V_COUNT
         FROM FERIFILI
         WHERE (CDFILIAL   = P_FILIAL)
           AND (DTFERIFILI = V_DTAUX);

         IF V_COUNT > 0 THEN
            V_RESULT := V_RESULT - 1;
         END IF;
      END LOOP;
   END IF;

   IF V_SALDO < 0 THEN
      WHILE V_SALDO <> 0 LOOP
         V_SALDO := V_SALDO + 1;
         V_DTAUX := V_DTAUX + 1;

         SELECT COUNT(*) INTO V_COUNT
         FROM FERIFILI
         WHERE (CDFILIAL   = P_FILIAL)
           AND (DTFERIFILI = V_DTAUX);

         IF V_COUNT > 0 THEN
            V_RESULT := V_RESULT + 1;
         END IF;
      END LOOP;
   END IF;

   RETURN(V_RESULT);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SALDOSLA','0.00.000'); END;
/

